main()
{
	//maps\mp\mp_office_fx::main();
	//maps\createart\mp_office_art::main();
	maps\mp\_load::main();	
	
	maps\mp\_compass::setupMiniMap("compass_map_mp_office");

	//setExpFog(500, 2200, 0.81, 0.75, 0.63, 0);
	//VisionSetNaked( "mp_office" );
	ambientPlay("ambient_office_ext");

	game["allies"] = "sas";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar( "r_specularcolorscale", "1" );
	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","1800");

	//background music code
	musicbackground = getent ("music","targetname");
	musicbackground thread music();
	level.musicfinished = false;

	//sound clip code
	sound_andy = getent("trig_sound_andy","targetname");
	sound_andy thread play_sound_andy();
	sound_angela = getent("trig_sound_angela","targetname");
	sound_angela thread play_sound_angela();
	sound_breakroom = getent("trig_sound_breakroom","targetname");
	sound_breakroom thread play_sound_breakroom();
	sound_conference = getent("trig_sound_conference","targetname");
	sound_conference thread play_sound_conference();
	sound_creed = getent("trig_sound_creed","targetname");
	sound_creed thread play_sound_creed();
	sound_darryl = getent("trig_sound_darryl","targetname");
	sound_darryl thread play_sound_darryl();
	sound_dwight = getent("trig_sound_dwight","targetname");
	sound_dwight thread play_sound_dwight();
	sound_jim = getent("trig_sound_jim","targetname");
	sound_jim thread play_sound_jim();
	sound_kelly = getent("trig_sound_kelly","targetname");
	sound_kelly thread play_sound_kelly();
	sound_kevin = getent("trig_sound_kevin","targetname");
	sound_kevin thread play_sound_kevin();
	sound_michael = getent("trig_sound_michael","targetname");
	sound_michael thread play_sound_michael();
	sound_pam = getent("trig_sound_pam","targetname");
	sound_pam thread play_sound_pam();
	sound_security = getent("trig_sound_security","targetname");
	sound_security thread play_sound_security();
	sound_toby = getent("trig_sound_toby","targetname");
	sound_toby thread play_sound_toby();
	sound_womenbathroom = getent("trig_sound_womenbathroom","targetname");
	sound_womenbathroom thread play_sound_womenbathroom();

	//door code
	trigdoorswing = getentarray("trigdoorswing","targetname");
	for(i=0;i<trigdoorswing.size;i++)
	{
		if (trigdoorswing[i].script_noteworthy == "ccw")
		{
		trigdoorswing[i].intswingdirection = 1;
		}
		else
		{
		trigdoorswing[i].intswingdirection = -1;		
		}
		trigdoorswing[i].doormodel = getent(trigdoorswing[i].target, "targetname");
		trigdoorswing[i].doormodel.doormoving = false;
		trigdoorswing[i].doormodel.doorclosed = true;
		trigdoorswing[i].doormodel.time = 0.7; //how long it takes the door to swing
		trigdoorswing[i] thread doorswing();
	}
	doorknob = getentarray("doorknob","targetname");
	for(i=0;i<doorknob.size;i++)
	{
		doorknob[i] notSolid();
		doorknob[i].doormodel = getent(doorknob[i].target, "targetname");
		doorknob[i] linkto (doorknob[i].doormodel);
	}
	doorknob_static = getentarray("doorknob_static","targetname");
	for(i=0;i<doorknob_static.size;i++)
	{
		doorknob_static[i] notSolid();
	}

	//elevator and switch code
	trig_power_switch = getentarray("trig_power_switch","targetname");
	level.power_on = true;
	for(i=0;i<trig_power_switch.size;i++)
	{
		trig_power_switch[i].switchmodel = getent(trig_power_switch[i].target, "targetname");
		trig_power_switch[i].switchmodel notsolid();
		trig_power_switch[i].switchmodel.switchmoving = false;
		trig_power_switch[i].switchmodel.switchup = true;
		trig_power_switch[i].switchmodel.time = 0.5; //how long it takes the switch to swing
		trig_power_switch[i] thread switchswing();
	}

	level.elevator = getent("elevator","targetname");
	level.elevator_floor_top = getent("elevator_floor_top","targetname");
	level.elevator_floor_bottom = getent("elevator_floor_bottom","targetname");
	level.elevator_door_inside_left = getent("elevator_door_inside_left","targetname");
	level.elevator_door_inside_right = getent("elevator_door_inside_right","targetname");
	level.elevator_door_downstairs_left = getent("elevator_door_downstairs_left","targetname");
	level.elevator_door_downstairs_right = getent("elevator_door_downstairs_right","targetname");
	level.elevator_door_upstairs_left = getent("elevator_door_upstairs_left","targetname");
	level.elevator_door_upstairs_right = getent("elevator_door_upstairs_right","targetname");

	level.elevator_button_time = 0.1; //how long it takes the buttons to move
	level.elevator_button_move = 1; //how far the buttons move
	level.elevator_button_inside_in = false;
	level.elevator_button_downstairs_in = false;
	level.elevator_button_upstairs_in = false;
	level.elevator_door_time = 1; //how long it takes the doors to move
	level.elevator_door_move = 25; //how far the doors move
	level.elevator_doors_inside_open = false;
	level.elevator_doors_downstairs_open = false;
	level.elevator_doors_upstairs_open = false;
	level.elevator_time = 4; //total time it takes the elevator to move between floors
	level.elevator_distance = distance(level.elevator_floor_top.origin, level.elevator_floor_bottom.origin);
	level.elevator_interval_move = 1;
	level.elevator_position_min = 0;
	level.elevator_position_max = int(level.elevator_distance/level.elevator_interval_move);
	level.elevator_position = 0;
	level.elevator_interval_time = level.elevator_time/level.elevator_position_max;
	level.elevator_moving = 0; //0 = stay, -1 = down, 1 = up

	level.elevator_trig_crush = getent("trig_elevator_crush","targetname");
	level.elevator_trig_crush_script_model = spawn ("script_model",(0,0,0));
	level.elevator_trig_crush EnableLinkTo();
	level.elevator_trig_crush linkto (level.elevator_trig_crush_script_model);

	level.elevator_trig_doors_upstairs_inner = getent("trig_elevator_doors_upstairs_inner","targetname");
	level thread elevator_doors_upstairs_inner();

	level.elevator_trig_doors_upstairs_outer = getent("trig_elevator_doors_upstairs_outer","targetname");
	level thread elevator_doors_upstairs_outer();

	level.elevator_trig_button_inside = getent("trig_elevator_button_inside","targetname");
	level.elevator_button_inside = getent(level.elevator_trig_button_inside.target, "targetname");
	level thread elevator_button_inside_pushed_in();

	level.elevator_trig_button_downstairs = getent("trig_elevator_button_downstairs","targetname");
	level.elevator_button_downstairs = getent(level.elevator_trig_button_downstairs.target, "targetname");
	level thread elevator_button_downstairs_pushed_in();

	level.elevator_trig_button_upstairs = getent("trig_elevator_button_upstairs","targetname");
	level.elevator_button_upstairs = getent(level.elevator_trig_button_upstairs.target, "targetname");
	level thread elevator_button_upstairs_pushed_in();

	level.elevator_trig_ceiling = getentarray("trig_elevator_ceiling","targetname");
	for(i=0;i<level.elevator_trig_ceiling.size;i++)
	{
		level.elevator_trig_ceiling[i].ceiling = getent(level.elevator_trig_ceiling[i].target, "targetname");
		level.elevator_trig_ceiling[i].broken = false;
		level.elevator_trig_ceiling[i].ceiling linkto (level.elevator);
		level.elevator_trig_ceiling[i] EnableLinkTo();
		level.elevator_trig_ceiling[i] linkto (level.elevator);
		level.elevator_trig_ceiling[i] thread elevator_ceiling_break();
	}

	//grenadebutton code
	trig_grenade = getentarray("trig_grenade","targetname");
	for(i=0;i<trig_grenade.size;i++)
	{
		trig_grenade[i].grenadebuttonmodel = getent(trig_grenade[i].target, "targetname");
		trig_grenade[i].grenadebuttonmodel.grenadebuttonmoving = false;
		trig_grenade[i].grenadebuttonmodel.grenadebuttonup = true;
		trig_grenade[i].grenadebuttonmodel.time = 0.1; //how long it takes the grenadebutton to move
		trig_grenade[i] thread grenadebuttonmove();
	}

	//christmasbreak code
	trig_christmas = getent("trig_christmas","targetname");
	trig_christmas.breakables = getent(trig_christmas.target, "targetname");
	trig_christmas.broken = false;
	trig_christmas thread christmasbreak();
}

//background music code
music()
{
	wait(10);;
	self playsound("officetheme");
	wait(37);
	level.musicfinished = true;
}

//sound clip code
play_sound_andy()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("andy");
			wait(10);;
		}
	}
}

play_sound_angela()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("angela");
			wait(10);;
		}
	}
}

play_sound_breakroom()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("breakroom");
			wait(10);;
		}
	}
}

play_sound_conference()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("conference");
			wait(10);;
		}
	}
}

play_sound_creed()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("creed");
			wait(10);;
		}
	}
}

play_sound_darryl()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("darryl");
			wait(10);;
		}
	}
}

play_sound_dwight()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("dwight");
			wait(10);;
		}
	}
}

play_sound_jim()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("jim");
			wait(10);;
		}
	}
}

play_sound_kelly()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("kelly");
			wait(10);;
		}
	}
}

play_sound_kevin()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("kevin");
			wait(10);;
		}
	}
}

play_sound_michael()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("michael");
			wait(10);;
		}
	}
}

play_sound_pam()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("pam");
			wait(10);;
		}
	}
}

play_sound_security()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("security");
			wait(10);;
		}
	}
}

play_sound_toby()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("toby");
			wait(10);;
		}
	}
}

play_sound_womenbathroom()
{
	while (1)
	{
		self waittill("trigger", user);
		if (level.musicfinished)
		{
			user playlocalsound("womenbathroom");
			wait(10);;
		}
	}
}

//door code
doorswing()
{
	while (1)
	{
		self waittill("trigger");
		if(!self.doormodel.doormoving)
		{
			self.doormodel.doormoving = true;
			if(self.doormodel.doorclosed)
			{
				self.doormodel rotateyaw(self.intswingdirection * 90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				self.doormodel playsound("doormove");
				self.doormodel waittill("rotatedone");
				self.doormodel.doorclosed = false;
		
				//close door again
				wait 4;
				self.doormodel rotateyaw(self.intswingdirection * -90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				self.doormodel playsound("doormove");
				self.doormodel waittill("rotatedone");
				self.doormodel.doorclosed = true;		
			}
			self.doormodel.doormoving = false;			
		}
	}
}

//elevator and switch code
switchswing()
{
	while (1)
	{
		self waittill("trigger");
		if(!self.switchmodel.switchmoving)
		{
			self.switchmodel.switchmoving = true;
			if(self.switchmodel.switchup)
			{
				level.power_on = false;
				self.switchmodel rotatepitch(180,self.switchmodel.time,self.switchmodel.time*0.5,self.switchmodel.time*0.5);
				self.switchmodel waittill("rotatedone");
				self.switchmodel.switchup = false;
				level thread elevator_button_inside_move_out();
				level thread elevator_button_downstairs_move_out();
				level thread elevator_button_upstairs_move_out();
				setExpFog(0, 150, 0, 0, 0, 0.0);
			}
			else
			{
				level.power_on = true;
				self.switchmodel rotatepitch(-180,self.switchmodel.time,self.switchmodel.time*0.5,self.switchmodel.time*0.5);
				self.switchmodel waittill("rotatedone");
				self.switchmodel.switchup = true;
				if (level.elevator_moving == 1)
				{
					level thread elevator_up();
				}
				else if (level.elevator_moving == -1)
				{
					level thread elevator_down();
				}
				setExpFog(4000, 5000, 0, 0, 0, 0.0);
			}
			self.switchmodel.switchmoving = false;			
		}
	}
}

elevator_ceiling_break()
{
	while (1)
	{
		self waittill("trigger");
		if(!self.broken)
		{
			self playsound("break");
			self.ceiling notsolid();
			self.ceiling hide();
			self.broken = true;
		}
	}
}

elevator_doors_upstairs_inner()
{
	while (1)
	{
		self.elevator_trig_doors_upstairs_inner waittill("trigger");
		if(!self.elevator_doors_upstairs_open)
		{
			self thread elevator_doors_upstairs_move_open();
			wait(2);
			self thread elevator_doors_upstairs_move_closed();
		}
	}
}

elevator_doors_upstairs_outer()
{
	while (1)
	{
		self.elevator_trig_doors_upstairs_outer waittill("trigger");
		if(!self.elevator_doors_upstairs_open && !level.power_on)
		{
			self thread elevator_doors_upstairs_move_open();
			wait(2);
			self thread elevator_doors_upstairs_move_closed();
		}
	}
}

elevator_button_inside_pushed_in()
{
	while (1)
	{
		self.elevator_trig_button_inside waittill("trigger");
		if(!self.elevator_button_inside_in)
		{
			self thread elevator_button_inside_move_in();
			level waittill("elevator_button_inside_move_in_done");
			if(self.elevator_position>self.elevator_position_max)
			{
				if(self.power_on)
				{
					self thread elevator_down();
					level waittill("elevator_down_done");
				}
			}
			else if(self.elevator_position<self.elevator_position_min)
			{
				if(self.power_on)
				{
					self thread elevator_up();
					level waittill("elevator_up_done");
				}
			}
			self thread elevator_button_inside_move_out();
			level waittill("elevator_button_inside_move_out_done");
		}
	}
}

elevator_button_downstairs_pushed_in()
{
	while (1)
	{
		self.elevator_trig_button_downstairs waittill("trigger");
		if(!self.elevator_button_downstairs_in)
		{
			self thread elevator_button_downstairs_move_in();
			level waittill("elevator_button_downstairs_move_in_done");
			if (self.elevator_moving == 1 && self.elevator_button_inside_in)
			{
				level waittill("elevator_button_inside_move_out_done");
				wait(2);
			}
			if(self.power_on)
			{
				self thread elevator_down();
				level waittill("elevator_down_done");
			}
			self thread elevator_button_downstairs_move_out();
			level waittill("elevator_button_downstairs_move_out_done");
		}
	}
}

elevator_button_upstairs_pushed_in()
{
	while (1)
	{
		self.elevator_trig_button_upstairs waittill("trigger");
		if(!self.elevator_button_upstairs_in)
		{
			self thread elevator_button_upstairs_move_in();
			level waittill("elevator_button_upstairs_move_in_done");
			if (self.elevator_moving == -1 && self.elevator_button_inside_in)
			{
				level waittill("elevator_button_inside_move_out_done");
				wait(2);
			}
			if(self.power_on)
			{
				self thread elevator_up();
				level waittill("elevator_up_done");
			}
			self thread elevator_button_upstairs_move_out();
			level waittill("elevator_button_upstairs_move_out_done");
		}
	}
}

elevator_button_inside_move_in()
{
	if(!self.elevator_button_inside_in)
	{
		self.elevator_button_inside movex(-1*self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_inside waittill("movedone");
		self.elevator_button_inside_in = true;
	}
	wait(0.01);
	level notify("elevator_button_inside_move_in_done");
}

elevator_button_downstairs_move_in()
{
	if(!self.elevator_button_downstairs_in)
	{
		self.elevator_button_downstairs movex(self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_downstairs waittill("movedone");
		self.elevator_button_downstairs_in = true;
	}
	wait(0.01);
	level notify("elevator_button_downstairs_move_in_done");
}

elevator_button_upstairs_move_in()
{
	if(!self.elevator_button_upstairs_in)
	{
		self.elevator_button_upstairs movex(self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_upstairs waittill("movedone");
		self.elevator_button_upstairs_in = true;
	}
	wait(0.01);
	level notify("elevator_button_upstairs_move_in_done");
}

elevator_button_inside_move_out()
{
	if(self.elevator_button_inside_in)
	{
		self.elevator_button_inside movex(self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_inside waittill("movedone");
		self.elevator_button_inside_in = false;
	}
	wait(0.01);
	level notify("elevator_button_inside_move_out_done");
}

elevator_button_downstairs_move_out()
{
	if(self.elevator_button_downstairs_in)
	{
		self.elevator_button_downstairs movex(-1*self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_downstairs waittill("movedone");
		self.elevator_button_downstairs_in = false;
	}
	wait(0.01);
	level notify("elevator_button_downstairs_move_out_done");
}

elevator_button_upstairs_move_out()
{
	if(self.elevator_button_upstairs_in)
	{
		self.elevator_button_upstairs movex(-1*self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_upstairs waittill("movedone");
		self.elevator_button_upstairs_in = false;
	}
	wait(0.01);
	level notify("elevator_button_upstairs_move_out_done");
}

elevator_doors_inside_move_open()
{
	if(!self.elevator_doors_inside_open)
	{
		self.elevator_door_inside_left movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_inside_right movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_inside_left waittill("movedone");
		self.elevator_doors_inside_open = true;
	}
	wait(0.01);
	level notify("elevator_doors_inside_move_open_done");
}

elevator_doors_downstairs_move_open()
{
	if(!self.elevator_doors_downstairs_open)
	{
		self.elevator_door_downstairs_left movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_downstairs_right movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_downstairs_left waittill("movedone");
		self.elevator_doors_downstairs_open = true;
	}
	wait(0.01);
	level notify("elevator_doors_downstairs_move_open_done");
}

elevator_doors_upstairs_move_open()
{
	if(!self.elevator_doors_upstairs_open)
	{
		self.elevator_door_upstairs_left movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_upstairs_right movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_upstairs_left waittill("movedone");
		self.elevator_doors_upstairs_open = true;
	}
	wait(0.01);
	level notify("elevator_doors_upstairs_move_open_done");
}

elevator_doors_inside_move_closed()
{
	if(self.elevator_doors_inside_open)
	{
		self.elevator_door_inside_left movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_inside_right movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_inside_left waittill("movedone");
		self.elevator_doors_inside_open = false;
	}
	wait(0.01);
	level notify("elevator_doors_inside_move_closed_done");
}

elevator_doors_downstairs_move_closed()
{
	if(self.elevator_doors_downstairs_open)
	{
		self.elevator_door_downstairs_left movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_downstairs_right movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_downstairs_left waittill("movedone");
		self.elevator_doors_downstairs_open = false;
	}
	wait(0.01);
	level notify("elevator_doors_downstairs_move_closed_done");
}

elevator_doors_upstairs_move_closed()
{
	if(self.elevator_doors_upstairs_open)
	{
		self.elevator_door_upstairs_left movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_upstairs_right movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_upstairs_left waittill("movedone");
		self.elevator_doors_upstairs_open = false;
	}
	wait(0.01);
	level notify("elevator_doors_upstairs_move_closed_done");
}

elevator_up()
{
	if(self.elevator_position<=self.elevator_position_max && self.power_on)
	{
		if(self.elevator_doors_inside_open)
		{
			self thread elevator_doors_downstairs_move_closed();
			self thread elevator_doors_upstairs_move_closed();
			self thread elevator_doors_inside_move_closed();
			level waittill("elevator_doors_inside_move_closed_done");
			self.elevator playsound("elevatormusic");
		}
		else
		{
			self thread elevator_doors_downstairs_move_closed();
			self thread elevator_doors_upstairs_move_closed();
			self thread elevator_doors_inside_move_closed();
			level waittill("elevator_doors_inside_move_closed_done");
		}
		self thread elevator_button_inside_move_in();
		level waittill("elevator_button_inside_move_in_done");
		for(i=self.elevator_position;i<=self.elevator_position_max;i++)
		{
			if(self.power_on)
			{
				self.elevator_moving = 1;
				self.elevator_button_inside linkto(self.elevator);
				self.elevator_door_inside_left linkto(self.elevator);
				self.elevator_door_inside_right linkto(self.elevator);
				self.elevator moveto(self.elevator_floor_bottom.origin+i*(0,0,self.elevator_interval_move),self.elevator_interval_time);
				self.elevator_trig_crush_script_model moveto((0,0,-1),self.elevator_interval_time);
				self.elevator waittill("movedone");
				self.elevator_button_inside unlink();
				self.elevator_door_inside_left unlink();
				self.elevator_door_inside_right unlink();			
				self.elevator_position = self.elevator_position + 1;
			}
		}
		self.elevator_trig_crush_script_model moveto((0,0,0),self.elevator_interval_time);
		self thread elevator_button_upstairs_move_out();
		level waittill("elevator_button_upstairs_move_out_done");
		self thread elevator_button_inside_move_out();
		level waittill("elevator_button_inside_move_out_done");
		if(self.power_on)
		{
			self.elevator playsound("elevatording");
			self thread elevator_doors_upstairs_move_open();
			self thread elevator_doors_inside_move_open();
			level waittill("elevator_doors_inside_move_open_done");
			self.elevator_moving = 0;
		}
	}
	wait(0.01);
	level notify("elevator_up_done");
}

elevator_down()
{
	if(self.elevator_position>=self.elevator_position_min && self.power_on)
	{
		if(self.elevator_doors_inside_open)
		{
			self thread elevator_doors_downstairs_move_closed();
			self thread elevator_doors_upstairs_move_closed();
			self thread elevator_doors_inside_move_closed();
			level waittill("elevator_doors_inside_move_closed_done");
			self.elevator playsound("elevatormusic");
		}
		else
		{
			self thread elevator_doors_downstairs_move_closed();
			self thread elevator_doors_upstairs_move_closed();
			self thread elevator_doors_inside_move_closed();
			level waittill("elevator_doors_inside_move_closed_done");
		}
		self thread elevator_button_inside_move_in();
		level waittill("elevator_button_inside_move_in_done");
		for(i=self.elevator_position;i>=self.elevator_position_min;i--)
		{
			if(self.power_on)
			{
				self.elevator_moving = -1;
				self.elevator_button_inside linkto(self.elevator);
				self.elevator_door_inside_left linkto(self.elevator);
				self.elevator_door_inside_right linkto(self.elevator);
				self.elevator moveto(self.elevator_floor_bottom.origin+i*(0,0,self.elevator_interval_move),self.elevator_interval_time);
				self.elevator waittill("movedone");
				self.elevator_button_inside unlink();
				self.elevator_door_inside_left unlink();
				self.elevator_door_inside_right unlink();			
				self.elevator_position = self.elevator_position - 1;
			}
		}
		self thread elevator_button_downstairs_move_out();
		level waittill("elevator_button_downstairs_move_out_done");
		self thread elevator_button_inside_move_out();
		level waittill("elevator_button_inside_move_out_done");
		if(self.power_on)
		{
			self.elevator playsound("elevatording");
			self thread elevator_doors_downstairs_move_open();
			self thread elevator_doors_inside_move_open();
			level waittill("elevator_doors_inside_move_open_done");
			self.elevator_moving = 0;
		}
	}
	wait(0.01);
	level notify("elevator_down_done");
}

//grenadebutton code
grenadebuttonmove()
{
	while (1)
	{
		self waittill("trigger", user);
		if(!self.grenadebuttonmodel.grenadebuttonmoving)
		{
			self.grenadebuttonmodel.grenadebuttonmoving = true;
			if (user GetWeaponAmmoClip("frag_grenade_mp") < 4)
			{
				self playsound("givegrenade");
				user givemaxammo("frag_grenade_mp");
				wait(0.01);
			}
			self.grenadebuttonmodel movez(-1,self.grenadebuttonmodel.time);
			self.grenadebuttonmodel waittill("movedone");
			self.grenadebuttonmodel movez(1,self.grenadebuttonmodel.time);
			self.grenadebuttonmodel waittill("movedone");
			self.grenadebuttonmodel.grenadebuttonmoving = false;			
		}
	}
}

//christmasbreak code
christmasbreak()
{
	while (1)
	{
		self waittill("trigger", user);
		if(!self.broken)
		{
			self playsound("break");
			self.breakables notsolid();
			self.breakables hide();
			self.broken = true;
		}
	}
}